' Vetor da ordem dos equipamentos no circuito
Global ordem_circuito(25, 2) As Single

' Variaveis referentes as dimensoes do circuito
Global AA, BB, CC, DD, EE, FF As Single
Global XXX, YYY As Single

' Variavel referente a quantidade de equipamentos
Global ii, n_equip As Single


Global motor As Integer
Global N_bar As Integer
Global onde As Integer

Sub Desenha_Circuito ()
                    
    '  No caso de haver motor no circuito, este deve estar
    '  no inicio do vetor, pois  um equipamento terminal
    
    For i = 1 To 24
        
        If ordem_circuito(i, 0) = 1 Then
            aux = ordem(i, 1)
            For k = 0 To 1
                For j = 0 To (i - 1)
                    ordem_circuito(i - j, k) = ordem_circuito(i - j - 1, k)
                    ordem(i - j, k) = ordem(i - j - 1, k)
                Next j
            Next k
            ordem_circuito(0, 0) = 1
            ordem_circuito(0, 1) = 0
            ordem(0, 0) = 1
            ordem(0, 1) = aux
            i = 24
        
            'correo referente aos valores de linha
            ordem(0, 1) = 0
            For k = 1 To 24
                ordem(k, 1) = ordem(k, 1) + 1
            Next k

        End If
       
    Next i
    
    ReDim aux1(30) As Single

    For i = 1 To 30
        
        If Equipamento(i, 30) = 1 Then
            For k = 0 To 30
                aux1(k) = Equipamento(i, k)
            Next k
            For k = 0 To 30
                For j = 0 To (i - 1)
                    Equipamento(i - j, k) = Equipamento(i - j - 1, k)
                Next j
            Next k
            For k = 0 To 30
                Equipamento(0, k) = aux1(k)
            Next k
            
            'correo da matriz na linha zero (posiao)
            Equipamento(0, 0) = 0
            For k = 1 To 30
                Equipamento(k, 0) = Equipamento(k, 0) + 1
            Next k
            
            i = 30
        End If
       
    Next i
    

    For i = 0 To 19
        If ordem_circuito(i, 0) = 0 Then
            n_equip = i
            i = 19
        End If
    Next i
    
    
    FormCircuito.Cls

    XXX = FormCircuito.ScaleWidth
    YYY = FormCircuito.ScaleHeight
     
    k = .7
    ddx = (XXX - (YYY - 60) * k) / 2
    ddy = (YYY - (XXX - 60) / k) / 2
    
    If ddx < 30 Then
        AA = 30
        BB = XXX - 30
        CC = ddy
        DD = (XXX - 60) / k + ddy
    Else
        AA = ddx
        BB = (YYY - 60) * k + ddx
        CC = 30
        DD = YYY - 30
    
    End If

   
    If n_equip <> 0 Then
        H = (DD - CC) / n_equip    'comprimento do simbolo - vertical
    End If
    
    
    ' Muda o tamanho da fonte com a mudanca no numero de equipamentos
    
     j = Int(10 - n_equip * 1.5)
     Select Case j
                Case 0: FormCircuito.FontSize = 6
                Case 1: FormCircuito.FontSize = 8.25
                Case 2: FormCircuito.FontSize = 9.75
                Case 3: FormCircuito.FontSize = 12
                Case 4: FormCircuito.FontSize = 13.5
                Case 5: FormCircuito.FontSize = 15
                Case 6: FormCircuito.FontSize = 17.25
                Case 7: FormCircuito.FontSize = 18
                Case 8: FormCircuito.FontSize = 22.5
                Case 9: FormCircuito.FontSize = 48
    End Select
        
    For ii = 0 To 24
        
        If ordem_circuito(ii, 0) = 1 Then
            Simbolo_Motor AA, BB, CC + (n_equip - ii - 1) * H, DD - (ii * H)
            motor = True
        End If
        
        If ordem_circuito(ii, 0) = 2 Then
            Simbolo_Trafo AA, BB, CC + (n_equip - ii - 1) * H, DD - (ii * H), n_equip
        End If

        If ordem_circuito(ii, 0) = 3 Then
            Simbolo_NH AA, BB, CC + (n_equip - ii - 1) * H, DD - (ii * H)
        End If
        
        If ordem_circuito(ii, 0) = 4 Then
            Simbolo_Cabo AA, BB, CC + (n_equip - ii - 1) * H, DD - (ii * H)
        End If

        If ordem_circuito(ii, 0) = 5 Then
            Simbolo_Diazed AA, BB, CC + (n_equip - ii - 1) * H, DD - (ii * H)
        End If
        
        If ordem_circuito(ii, 0) = 6 Then
            Simbolo_Disjuntor AA, BB, CC + (n_equip - ii - 1) * H, DD - (ii * H)
        End If
        
        If ordem_circuito(ii, 0) = 7 Or ordem_circuito(ii, 0) = 8 Or ordem_circuito(ii, 0) = 9 Or ordem_circuito(ii, 0) = 10 Then
            Simbolo_Rele1 AA, BB, CC + (n_equip - ii - 1) * H, DD - (ii * H), n_equip
        End If

        If ordem_circuito(ii, 0) = 11 Then
            Simbolo_Termico AA, BB, CC + (n_equip - ii - 1) * H, DD - (ii * H), n_equip
        End If
        
        If ordem_circuito(ii, 0) = 12 Then
            Simbolo_Barra AA, BB, CC + (n_equip - ii - 1) * H, DD - (ii * H)
        End If
        
        If ordem_circuito(ii, 0) = 13 Then
            Simbolo_Disjuntor AA, BB, CC + (n_equip - ii - 1) * H, DD - (ii * H)
        End If
        
        If ordem_circuito(ii, 0) = 0 Then
            ii = 24
        End If
    Next ii
    





End Sub

Sub Simbolo_Barra (X1, X2, Y1, Y2 As Single)
    
    EE = (X2 + X1) / (3 * n_equip)
    FF = (X2 + X1) / 2

    
    FormCircuito.ForeColor = corbarra
    FormCircuito.Line ((X1 + X2) / 2, Y1)-((X1 + X2) / 2, Y2)
    'FormCircuito.Circle (FF * 1.05, ((Y1 + Y2) * 1.03) / 2), 0
    FormCircuito.CurrentX = 1.05 * (X1 + X2) / 2
    FormCircuito.CurrentY = 1.01 * (Y1 + Y2) / 2
    FormCircuito.Print ordem_circuito(ii, 1);
    FormCircuito.Print "A"
    FormCircuito.DrawWidth = 6
    FormCircuito.Line (FF - EE, (Y1 + Y2) / 2)-(FF + EE, (Y1 + Y2) / 2)
    FormCircuito.DrawWidth = 1
    FormCircuito.CurrentX = X1 - 50
    FormCircuito.CurrentY = Y1
    FormCircuito.Print ii + 1 + " - Barramento"

    

End Sub

Sub Simbolo_Cabo (X1, X2, Y1, Y2 As Single)

    FormCircuito.DrawWidth = 3
    FormCircuito.ForeColor = corcabo
    FormCircuito.Line ((X1 + X2) / 2, Y1)-((X1 + X2) / 2, Y2)
    FormCircuito.DrawWidth = 1
    FormCircuito.CurrentX = X1 - 50
    FormCircuito.CurrentY = Y1
    FormCircuito.Print ii + 1 + " - Cabo"
    
End Sub

Sub Simbolo_Diazed (X1, X2, Y1, Y2 As Single)

    Ht = Y2 - Y1
    Bt = X2 - X1
    H = Ht / 2
    B = H / 2
    FormCircuito.ForeColor = corfusdia
    FormCircuito.Line (X1 + (Bt - B) / 2, Y1 + H / 2)-((2 * X1 + B + Bt) / 2, 3 * Ht / 4 + Y1), , B
    FormCircuito.Line (X1 + (Bt - B) / 2, Y1 + 3 * Ht / 8)-((2 * X1 + B + Bt) / 2, Y1 + 5 * Ht / 8), , B
    FormCircuito.Line ((X2 + X1) / 2, Y1)-((X2 + X1) / 2, (Y2 + 3 * Y1) / 4)
    FormCircuito.Line ((X2 + X1) / 2, Y2)-((X2 + X1) / 2, (3 * Y2 + Y1) / 4)
    FormCircuito.CurrentX = X1 - 50
    FormCircuito.CurrentY = Y1
    FormCircuito.Print ii + 1 + " - Fusvel Diazed"
    
End Sub

Sub Simbolo_Disjuntor (X1, X2, Y1, Y2 As Single)

    H = (Y2 - Y1)
    FormCircuito.ForeColor = cordisj
    FormCircuito.Circle ((X1 + X2) / 2, (Y1 + Y2) / 2), H / 3, , 5.061455, 1.22173, 2
    FormCircuito.Circle ((X1 + X2) / 2, Y1 + H / 4), H / 25
    FormCircuito.Circle ((X1 + X2) / 2, Y2 - H / 4), H / 25
    FormCircuito.Line ((X1 + X2) / 2, Y1)-((X1 + X2) / 2, Y1 + .21 * H)
    FormCircuito.Line ((X1 + X2) / 2, Y2 - .21 * H)-((X1 + X2) / 2, Y2)
    FormCircuito.CurrentX = X1 - 50
    FormCircuito.CurrentY = Y1
    FormCircuito.Print ii + 1 + " - Disjuntor GE"
    
End Sub

Sub Simbolo_Motor (X1, X2, Y1, Y2 As Single)

    Xc = (X2 + X1) / 2
    Yc = (2 * Y2 + Y1) / 3
    RAIO = (Y2 - Y1) / 3
    
    FormCircuito.ForeColor = cormotor
    FormCircuito.Circle (Xc, Yc), RAIO
    FormCircuito.Line (Xc - RAIO / 2, Yc + RAIO / 2)-(Xc - RAIO / 2, Yc - RAIO / 2)
    FormCircuito.Line -(Xc, Yc)
    FormCircuito.Line -(Xc + RAIO / 2, Yc - RAIO / 2)
    FormCircuito.Line -(Xc + RAIO / 2, Yc + RAIO / 2)
    FormCircuito.Line (Xc, Yc - RAIO)-(Xc, Y1)
    FormCircuito.CurrentX = X1 - 50
    FormCircuito.CurrentY = Y1
    FormCircuito.Print ii + 1 + " - Motor"


End Sub

Sub Simbolo_NH (X1, X2, Y1, Y2 As Single)


    Ht = Y2 - Y1
    Bt = X2 - X1
    H = Ht / 2
    B = H / 2
    FormCircuito.ForeColor = corfusnh
    FormCircuito.Line (X1 + (Bt - B) / 2, Y1 + H / 2)-((2 * X1 + B + Bt) / 2, 3 * Ht / 4 + Y1), , B
    FormCircuito.Line (X1 + (Bt - B) / 2, Y1 + 3 * Ht / 8)-((2 * X1 + B + Bt) / 2, Y1 + 5 * Ht / 8), , B
    FormCircuito.Line ((X2 + X1) / 2, Y1)-((X2 + X1) / 2, (Y2 + 3 * Y1) / 4)
    FormCircuito.Line ((X2 + X1) / 2, Y2)-((X2 + X1) / 2, (3 * Y2 + Y1) / 4)
    FormCircuito.CurrentX = X1 - 50
    FormCircuito.CurrentY = Y1
    FormCircuito.Print ii + 1 + " - Fusvel NH"
    
End Sub

Sub Simbolo_Rele1 (X1, X2, Y1, Y2, n As Single)

    Ht = Y2 - Y1
    Bt = X2 - X1
    FormCircuito.ForeColor = CorRele
    If n <= 3 Then
        Bd = Ht / 6
        FormCircuito.Line ((X1 + ((Bt - Bd) / 2)), Y1 + (Ht / 8))-((X1 + ((Bt + Bd) / 2)), Y1 + (3 * Ht / 8)), , B
        FormCircuito.Circle ((X1 + X2) / 2, Y1 + 3 * Ht / 4), Bd / 3
        FormCircuito.Circle ((X1 + (3 * Bt / 4)), Y1 + 3 * Ht / 4), Bd / 2
        FormCircuito.Line ((X1 + X2) / 2, Y1)-((X1 + X2) / 2, Y1 + Ht / 8)
        FormCircuito.Line ((X1 + X2) / 2, Y1 + (3 * Ht / 8))-((X1 + X2) / 2, Y2)
        FormCircuito.Line ((X1 + X2) / 2 + Bd / 3, Y1 + (3 * Ht / 4))-(X1 + (3 * Bt / 4) - Bd / 2, Y1 + (3 * Ht / 4))
        FormCircuito.Line (X1 + (3 * Bt / 4), Y1 + (3 * Ht / 4) - Bd / 2)-(X1 + (3 * Bt / 4), Y1 + Ht / 4)
        FormCircuito.Line (X1 + (3 * Bt / 4), Y1 + Ht / 4)-((X1 + X2) / 2 + Bd / 2, Y1 + Ht / 4)
    End If
        
    If n > 3 Then
        Bd = Ht / 4
        FormCircuito.Line ((X1 + ((Bt - Bd) / 2)), Y1 + (Ht / 8))-((X1 + ((Bt + Bd) / 2)), Y1 + (3 * Ht / 8)), , B
        FormCircuito.Circle ((X1 + X2) / 2, Y1 + 3 * Ht / 4), Bd / 3
        FormCircuito.Circle (((X1 + X2) / 2) + Ht / 2, Y1 + 3 * Ht / 4), Bd / 2
        FormCircuito.Line ((X1 + X2) / 2, Y1)-((X1 + X2) / 2, Y1 + Ht / 8)
        FormCircuito.Line ((X1 + X2) / 2, Y1 + (3 * Ht / 8))-((X1 + X2) / 2, Y2)
        FormCircuito.Line ((X1 + X2) / 2 + Bd / 3, Y1 + (3 * Ht / 4))-(((X1 + X2) / 2) + Ht / 2 - Bd / 2, Y1 + (3 * Ht / 4))
        FormCircuito.Line (((X1 + X2) / 2) + Ht / 2, Y1 + (3 * Ht / 4) - Bd / 2)-(((X1 + X2) / 2) + Ht / 2, Y1 + Ht / 4)
        FormCircuito.Line -((X1 + X2) / 2 + Bd / 2, Y1 + Ht / 4)
    End If
    FormCircuito.CurrentX = X1 - 50
    FormCircuito.CurrentY = Y1
    FormCircuito.Print ii + 1 + " - Rel 50/51"

End Sub

Sub Simbolo_Termico (X1, X2, Y1, Y2, n As Single)

    Ht = Y2 - Y1
    Bt = X2 - X1
    FormCircuito.ForeColor = Cortermico
    Ub = Bt / 10
    Uh = Ht / 8

    If n <= 3 Then

        FormCircuito.Line ((X1 + X2) / 2, Y1)-((X1 + X2) / 2, Y1 + Uh)
        FormCircuito.Line (X1 + (6 * Ub), Y1 + Uh)-((X1 + X2) / 2, Y1 + 3 * Uh)
        FormCircuito.Line -((X1 + X2) / 2, Y1 + 5 * Uh)
        FormCircuito.Line -(X1 + 6 * Ub, Y1 + 5 * Uh)
        FormCircuito.Line -(X1 + 6 * Ub, Y1 + 6 * Uh)
        FormCircuito.Line -(X1 + 4 * Ub, Y1 + 6 * Uh)
        FormCircuito.Line -(X1 + 4 * Ub, Y1 + 6 * Uh)
        FormCircuito.Line -(X1 + 4 * Ub, Y1 + 7 * Uh)
        FormCircuito.Line -(X1 + 5 * Ub, Y1 + 7 * Uh)
        FormCircuito.Line -(X1 + 5 * Ub, Y2)
        FormCircuito.Line (X1 + 5.5 * Ub, Y1 + 2 * Uh)-(X1 + 7 * Ub, Y1 + 2 * Uh)
        FormCircuito.Line (X1 + 7 * Ub, Y1 + Uh)-(X1 + 9 * Ub, Y1 + 3 * Uh), , B
        FormCircuito.Line (X1 + 9 * Ub, Y1 + Uh)-(X1 + 7 * Ub, Y1 + 3 * Uh)
        FormCircuito.Line (X1 + 8 * Ub, Y1 + 3 * Uh)-(X1 + 8 * Ub, Y1 + 5.5 * Uh)
        FormCircuito.Line -(X1 + 6 * Ub, Y1 + 5.5 * Uh)
    End If
        
    If n > 3 Then
        FormCircuito.Line ((X1 + X2) / 2, Y1)-((X1 + X2) / 2, Y1 + Uh)
        FormCircuito.Line (((X1 + X2) / 2) + 2 * Uh, Y1 + Uh)-((X1 + X2) / 2, Y1 + 3 * Uh)
        FormCircuito.Line -((X1 + X2) / 2, Y1 + 5 * Uh)
        FormCircuito.Line -(((X1 + X2) / 2) + 2 * Uh, Y1 + 5 * Uh)
        FormCircuito.Line -(((X1 + X2) / 2) + 2 * Uh, Y1 + 6 * Uh)
        FormCircuito.Line -(((X1 + X2) / 2) - 2 * Uh, Y1 + 6 * Uh)
        FormCircuito.Line -(((X1 + X2) / 2) - 2 * Uh, Y1 + 7 * Uh)
        FormCircuito.Line -(((X1 + X2) / 2), Y1 + 7 * Uh)
        FormCircuito.Line -(((X1 + X2) / 2), Y1 + 8 * Uh)
        
        FormCircuito.Line (((X1 + X2) / 2) + Uh, Y1 + 2 * Uh)-(((X1 + X2) / 2) + Ht / 2, Y1 + 2 * Uh)
        FormCircuito.Line (((X1 + X2) / 2) + Ht / 2, Y1 + Uh)-(((X1 + X2) / 2) + Ht, Y1 + 3 * Uh), , B
        FormCircuito.Line (((X1 + X2) / 2) + Ht, Y1 + Uh)-(((X1 + X2) / 2) + Ht / 2, Y1 + 3 * Uh)
        FormCircuito.Line (((X1 + X2) / 2) + 3 * Ht / 4, Y1 + 3 * Uh)-(((X1 + X2) / 2) + 3 * Ht / 4, Y1 + 5.5 * Uh)
        FormCircuito.Line -(((X1 + X2) / 2) + 2 * Uh, Y1 + 5.5 * Uh)
        
    End If
    FormCircuito.CurrentX = X1 - 50
    FormCircuito.CurrentY = Y1
    FormCircuito.Print ii + 1 + " - Rel Trmico"

End Sub

Sub Simbolo_Trafo (X1, X2, Y1, Y2, n As Single)

    If n = 1 Then
        H = Y2 - Y1
        W = (X2 - X1) / 2
        delta = W / 2
    End If
    If n > 1 Then
        H = Y2 - Y1
        W = H
        delta = (X2 - X1 - H) / 2
    End If

    FormCircuito.ForeColor = QBColor(12)
    FormCircuito.Line (X1 + delta, Y1 + H / 5)-(X1 + delta + W / 6, Y1 + 2 * H / 5)
    FormCircuito.Line -(X1 + delta + 2 * W / 6, Y1 + H / 5)
    FormCircuito.Line -(X1 + delta + 3 * W / 6, Y1 + 2 * H / 5)
    FormCircuito.Line -(X1 + delta + 4 * W / 6, Y1 + H / 5)
    FormCircuito.Line -(X1 + delta + 5 * W / 6, Y1 + 2 * H / 5)
    FormCircuito.Line -(X1 + delta + 6 * W / 6, Y1 + H / 5)
    
    
    FormCircuito.Line (X1 + delta, Y2 - H / 5)-(X1 + delta + W / 6, Y2 - 2 * H / 5)
    FormCircuito.Line -(X1 + delta + 2 * W / 6, Y2 - H / 5)
    FormCircuito.Line -(X1 + delta + 3 * W / 6, Y2 - 2 * H / 5)
    FormCircuito.Line -(X1 + delta + 4 * W / 6, Y2 - H / 5)
    FormCircuito.Line -(X1 + delta + 5 * W / 6, Y2 - 2 * H / 5)
    FormCircuito.Line -(X1 + delta + 6 * W / 6, Y2 - H / 5)

    FormCircuito.Line ((X1 + X2) / 2, Y1)-((X1 + X2) / 2, Y1 + 2 * H / 5)
    FormCircuito.Line ((X1 + X2) / 2, Y2)-((X1 + X2) / 2, Y2 - 2 * H / 5)

    FormCircuito.CurrentX = X1 - 50
    FormCircuito.CurrentY = Y1
    FormCircuito.Print ii + 1 + " - Transformador"
    
End Sub

